
import os
outbase = "output/" + os.path.splitext(os.path.basename(__file__))[0]

import sys
from pylab import *
from numpy import *

from opendeco import vpm, tracker, mix
from opendeco.diveseries import *
from opendeco.units import msw

m = mix.Air
m = mix.Tx(18,45)

deco = [
    (6*msw, mix.EAN(99)),
    (21*msw, mix.EAN(50))
]

depth = 80.0
time = 30.0

p = DiveProfile()
ch = SegmentChange(m, 0*msw, depth*msw, 30*msw)
p.addSegment(ch)
p.addSegment(SegmentLevel(m, depth*msw, time-ch.time))

v = vpm.VPM()
v.decoMixes = deco
v.runProfile(p)

nr_it = tracker.current.plotdata('vpm.iterations').y[0]
ran = range(1, nr_it+1)
pl = []
for i in ran:
    depth = tracker.current.plotdata('profile.depth')
    ddepth = tracker.current.plotdata('profile.deco.iter%i.depth' % i)
    x = array(depth.x.tolist() + ddepth.x.tolist())
    y = array(depth.y.tolist() + ddepth.y.tolist())
    pl.append( plot(x, -y*10, '-', linewidth=1) )

legend( pl, [ str(x) for x in ran ] )

savefig(outbase+'.png')

connect('button_press_event', lambda event: sys.exit(0)) 
#show()

