
import common
import os
outbase = common.outbase(__file__)

from pylab import *
from numpy import *

from opendeco import vpm, tracker, mix
from opendeco.units import msw

tracker.current.resolution = None

common.timer()

results = []

os.chdir('baker')

def plotProfileForMixes(bottom, deco, depth, divetime, label):
    tracker.current.data = {}

    p = common.simpleProfile(bottom, depth*1.013, divetime)

    v = vpm.VPM(conservatism=0)
    v.decoMixes = deco
    v.runProfile(p)

    print "*** %s" % label
    for sd, sl, sr, sm in v.lastSchedule:
        print "%3i %2i (%3i) %s" % (sd.msw, sl, sr, sm.shortname())
    
    # Erik Baker's results
    f = open('VPMDECO.IN', 'w')
    l = []
    l.append(label)
    # mixes
    l.append("%s" % (len(deco)+1))
    for g in [bottom] + [ x[1] for x in deco ]:
        ("%.2f,%.2f,%.2f" % (g.o2, g.he, g.n2))
        l.append("%.2f,%.2f,%.2f" % (g.o2, g.he, g.n2))
    # descent
    l.append('1')
    l.append('0,%i,30,1' % depth)
    # bottom
    l.append('2')
    l.append('%i,%i,1' % (depth, divetime))
    # deco
    l.append('99')
    # switches and stops
    l.append("%s" % (len(deco)+1))
    l.append('%i,1,-10,3' % (depth))
    i = 2
    for d, g in deco:
        l.append('%i,%i,-10,3' % (d.msw, i))
        i += 1
    l.append('0')
    #results.append( '\n'.join(l))
    f.write('\r\n'.join(l))   
    f.write('\r\n')   
    f.close()
    os.system('./vpmb-orig > /dev/null')
    #os.system('./vpmb')

    o = open('VPMDECO.OUT', 'r')
    lines = [ x for x in o ]
    o.close()
    baker = lines[-2].strip()[12:17]

    #results.append( "%i\t%i\t%s (%.1fm > %.1fm)" % (v.runtime, float(baker), 
    #    label, v.lastStartDecoZone.msw, v.lastFirstStop.msw))
    results.append( "%i &\t%i &\t%s & %.1fm & %.1fm \\\\" % (v.runtime, 
        float(baker), label, v.lastStartDecoZone.msw, v.lastFirstStop.msw))



deco_o2 = [(6*msw, mix.Oxygen)]
deco_50 = [(21*msw, mix.EAN(50))]
deco_both = deco_50 + deco_o2

def main(n, d=60, t=30, m=True):
    if m:
        plotProfileForMixes(tx, deco_both, d, t, n+' + O2 + 50')
        plotProfileForMixes(tx, deco_o2, d, t, n+' + O2')
        plotProfileForMixes(tx, deco_50, d, t, n+' + 50')
    plotProfileForMixes(tx, [], d, t, n)

tx = mix.Tx(18, 45)
main('30@60 Tx18/45')
tx = mix.Tx(18, 82)
main('30@60 Tx18/82')
tx = mix.Air
main('30@60 Air')
main('30@40 Air', 40, 30)
main('20@40 Air', 40, 20)
main('30@30 Air', 30, 30)
main('20@30 Air', 30, 20)
main('20@25 Air', 25, 20, False)
main('40@20 Air', 20, 40, False)
main('60@15 Air', 15, 60, False)
main('60@10 Air', 10, 60, False)

vplanner = [80, 108, 89, 157, 97, 153, 104, 256, 82, 102, 95, 137] + [0]*100
print "vpl\tmine\tbaker"
for r in results:
    print vplanner.pop(0), '\t', r


