
import common
outbase = common.outbase(__file__)

import sys
from pylab import *
from numpy import *

from opendeco import vpm, tracker, mix
from opendeco.diveseries import *
from opendeco.units import msw

common.timer()

depth = 60
divetime = 30

leg = []

def plotProfileForMixes(bottom, deco, label, cons=0):
    tracker.current.data = {}

    p = common.simpleProfile(bottom, depth, divetime)

    v = vpm.VPM(conservatism=cons)
    v.decoDepthInterval = 0.2 * msw
    v.alignStopTimes = 0.25
    v.decoMixes = deco
    v.runProfile(p)

    x, y = common.fullProfile()
    x, y = common.smoothplot(x, y, 5)
    pl = plot(x, -y, '-', linewidth=1)
    leg.append( (pl, label % v.runtime) )

air = mix.Air
tx = mix.Tx(18, 45)
deco_o2 = [(6*msw, mix.Oxygen)]
deco_50 = [(21*msw, mix.EAN(50))]
deco_36 = [(40*msw, mix.EAN(36))] # unsafe
deco_both = deco_o2 + deco_50

def main():
    for c in range(6):
        plotProfileForMixes(tx, deco_both, 'Conservatism +%i (%%i min)' % c, c)
        common.timer()

main()

l = legend( [ x[0] for x in leg ], [ x[1] for x in leg ], loc='best' )

title('Dive with Tx18/45 + EAN50 + O2 at various conservatism settings')
xlabel('Runtime (min)')
ylabel('Depth (m)')

savefig(outbase+common.ext())
savefig(outbase+'.eps')
common.show()

