"""
Creates a plot of depth versus crushing pressure for all tissues
Const: mix=air, rate=30 m/min

"""

import os
outbase = "output/" + os.path.splitext(os.path.basename(__file__))[0]

from pylab import *
from numpy import *

from opendeco import vpm, tracker, mix
from opendeco.diveseries import *
from opendeco.units import msw

m = mix.Air

results = []

for depth in range(1, 90, 10):
    # FIXME: more for impermeable
    p = DiveProfile()
    p.addSegment(SegmentChange(m, 0*msw, depth*msw, 30*msw))
    print depth
    v = vpm.VPM()
    v.runProfile(p)
    cr = v.maxPCrushN2
    results.append((depth, cr))

depths = array([ x[0] for x in results ])
tis = array([ x[1] for x in results ])

for i in range(15):
    plot(depths, tis[:,i])

title('Tissue crushing pressures (Air, descent rate 30m/min)')
xlabel('Depth (m)')
ylabel('Crushing pressure (bar)')

savefig(outbase+'.png')
show()

