"""
Creates a plot of descent rate versus crushing pressure for all tissues
Const: mix=air, depth=??

"""

import os
outbase = "output/" + os.path.splitext(os.path.basename(__file__))[0]

from pylab import *
from numpy import *

from opendeco import vpm, tracker, mix
from opendeco.diveseries import *
from opendeco.units import msw

m = mix.Air

results = []

depth = 40
for rate in range(5, 50, 1):
    # FIXME: more for impermeable
    p = DiveProfile()
    p.addSegment(SegmentChange(m, 0*msw, depth*msw, rate*msw))
    v = vpm.VPM()
    v.runProfile(p)
    cr = v.maxPCrushN2
    results.append((rate, cr))

rates = array([ x[0] for x in results ])
tis = array([ x[1] for x in results ])

for i in range(10):
    plot(rates, tis[:,i])

title('Tissue crushing pressures (Air, depth %im)' % depth)
xlabel('Descent rate (m/min)')
ylabel('Crushing pressure (bar)')

savefig(outbase+'.png')
show()

