
import common
outbase = common.outbase(__file__)

from pylab import *
from numpy import *

from opendeco import vpm, tracker, mix
from opendeco.units import msw

depth = 60
divetime = 30

common.timer()

leg = []

def plotProfileForMixes(bottom, deco, label):
    tracker.current.data = {}

    p = common.simpleProfile(bottom, depth, divetime)

    v = vpm.VPM(conservatism=2)
    #v.decoDepthInterval = 0.2 * msw
    #v.alignStopTimes = 0.25
    v.decoMixes = deco
    v.runProfile(p)

    x, y = common.fullProfile()
    #x, y = common.smoothplot(x, y, 10)
    pl = plot(x, -y, '-', linewidth=1)
    leg.append( (pl, label) )

tx = mix.Tx(18, 45)
deco_o2 = [(6*msw, mix.Oxygen)]
deco_50 = [(21*msw, mix.EAN(50))]
deco_36 = [(40*msw, mix.EAN(36))] # unsafe
deco_both = deco_o2 + deco_50

def main():
    plotProfileForMixes(tx, [], 'Tx18/45')
    common.timer()
    plotProfileForMixes(tx, deco_o2, 'Tx18/45 + O2')
    common.timer()
    plotProfileForMixes(tx, deco_50, 'Tx18/45 + EAN50')
    common.timer()
    plotProfileForMixes(tx, deco_both, 'Tx18/45 + EAN50 + O2')
    common.timer()

main()

legend( [ x[0] for x in leg ], [ x[1] for x in leg ], loc='best' )
title('Dive at conservatism +2 on Tx18/45 with various decogasses')
xlabel('Runtime (min)')
ylabel('Depth (m)')

common.savefig(outbase)

common.show()

