"""
Vary between Tx20/0 and Tx20/80
"""

import common
outbase = common.outbase(__file__)

import sys
import os
from numpy import *
import copy

from opendeco import vpm, tracker, mix, tissues
from opendeco.diveseries import *

import sensitivity

depth = 60
time = 20

m0 = []
m1 = [(21*msw, mix.EAN(50))]
m2 = [(6*msw, mix.Oxygen)]
m3 = [(6*msw, mix.Oxygen), (21*msw, mix.EAN(50))]

from pylab import *

xlabel('Helium in bottom mix (%)')
ylabel('Decompression time (min)')
title('20 minute dive to 60m (20% O2)')

for mixes in [m0, m1, m2, m3]:
    x = []
    y = []
    for he in range(0, 85, 5):
        tracker.current.data = {}
        m = mix.Tx(20, he)
        profile = common.simpleProfile(m, depth, time)
        kw = {
            'decoMixes' : mixes,
            'alignStopTimes' : 0.5,
            'decoDepthInterval' : 1 * msw
        }
        v = vpm.VPM(**kw)
        v.runProfile(profile)
        dt = v.runtime - time
        x.append(he)
        y.append(dt)
        print he, dt
    plot(x,y)

legend(['No decogas', 'EAN50', 'O2', 'EAN50 + O2'], loc='best')

common.savefig(outbase)
common.show()

