
import common
outbase = common.outbase(__file__)

from pylab import *
from numpy import *

from opendeco import vpm, tracker, mix
from opendeco.units import msw

common.timer()

leg = []

todo = [
    # depthstart starttime
#    (13, 200),
    (14, 100),
    (16, 60),
    (19, 30),
    (24, 15),
    (32, 1),
    (51, None)
]

cached_ndls = [(14, 159), (15, 119), (16, 93), (17, 76), (18, 65), (19, 55), (20, 47), (21, 41), (22, 37), (23, 33), (24, 29), (25, 27), (26, 25), (27, 23), (28, 21), (29, 20), (30, 19), (31, 17), (32, 16), (33, 14), (34, 14), (35, 13), (36, 12), (37, 12), (38, 12), (39, 11), (40, 10), (41, 10), (42, 9), (43, 9), (44, 9), (45, 8), (46, 8), (47, 8), (48, 8), (49, 7), (50, 7)]

#cached_ndls = []


def calculateNDLS():

    ndls = []

    for i in range(len(todo)):
        startdepth, starttime = todo[i]
        if not starttime:
            break
        enddepth = todo[i+1][0]
        for depth in range(startdepth, enddepth):
            ndl = 0
            for divetime in range(starttime, 600, 1):
                #print divetime,
                tracker.current.data = {}
                
                p = common.simpleProfile(mix.Air, depth, divetime)

                v = vpm.VPM(conservatism=0)
                v.decoMixes = []
                v.runProfile(p)

                
                if v.lastSchedule:
                    break

                ndl = divetime
            print "\nNDL for %i m = %i min" % (depth, ndl)
            ndls.append( (depth, ndl) )

    return ndls


if cached_ndls:
    n = cached_ndls
else:
    n = calculateNDLS()

print n

x = [ a[0] for a in n ]
y = [ a[1] for a in n ]

plot(x, y)

#legend( [ x[0] for x in leg ], [ x[1] for x in leg ], loc='best' )
title('No Decompression Limits for air dives')
xlabel('Depth (m)')
ylabel('NDL (min)')

savefig(outbase+common.ext())
savefig(outbase+'.eps')

common.show()

