"""
XXX Creates a plot of descent rate versus crushing pressure for all tissues
Const: mix=air, depth=??

"""

import os
outbase = "output/" + os.path.splitext(os.path.basename(__file__))[0]

import matplotlib
matplotlib.rc('text', usetex = True)

from pylab import *
from numpy import *

from opendeco import vpm, tracker, mix, vpmphysics
from opendeco.diveseries import *
from opendeco.units import msw

m = mix.Air

results = []

depth = 30
for rate in range(5, 50, 2):
    # FIXME: more for impermeable
    p = DiveProfile()
    p.addSegment(SegmentChange(m, 0*msw, depth*msw, rate*msw))
    v = vpm.VPM()
    v.runProfile(p)
    cr = v.maxPCrushN2
    r = vpmphysics.radiusAfterGradient(v.radiusN2, cr)
    results.append((rate, r))

rates = array([ x[0] for x in results ])
tis = array([ x[1] for x in results ])

first = None
for i in range(14):
    t = tis[:,i]
    last = plot(rates, t)
    if not first:
        first = last

legend( [first, last], ['Fastest tissue', 'Slowest tissue'], shadow=False)

title('Crushed bubble radii for various descent rates (Air, depth %im)' % depth)
# klopt het wel wat ik hier zeg?
xlabel('Descent rate (m/min)')
ylabel(r'Critical radius ($\mu$m)')

savefig(outbase+'.png')
savefig(outbase+'.eps')
show()

