
import common
outbase = common.outbase(__file__)

import sys
from pylab import *
from numpy import *

from opendeco import vpm, tracker, mix
from opendeco.diveseries import *
from opendeco.units import msw

m = mix.Air
m = mix.Tx(18,45)

deco = [
    (6*msw, mix.Oxygen),
    (21*msw, mix.EAN(50))
]

depth = 60.0*1.013
time = 30.0

p = common.simpleProfile(m, depth, time)
ch = SegmentChange(m, depth*msw, 40*1.013*msw, 10*msw)
#p.addSegment(ch)
#p.addSegment(SegmentLevel(m, 40*1.013*msw, 18))

v = vpm.VPM()
v.decoMixes = deco
v.runProfile(p)

common.printSchedule(v)

nr_it = tracker.current.plotdata('vpm.iterations').y[0]
ran = range(1, nr_it+1)
pl = []
for i in ran:
    x, y = common.fullProfile()
    pl.append( plot(x, -y, '-', linewidth=1) )

tracker.current.data = {}
v = vpm.VPM(useAllowableGradient=2)
v.decoMixes = deco
v.runProfile(p)

common.printSchedule(v)

nr_it = tracker.current.plotdata('vpm.iterations').y[0]
ran = range(1, nr_it+1)
pl = []
for i in ran:
    x, y = common.fullProfile()
    pl.append( plot(x, -y, '-', linewidth=1) )

legend( pl, [ "Baker's algerithm", "Weird 1999 version" ], loc='best' )

savefig(outbase+common.ext())
savefig(outbase+'.eps')
common.show()
