
import common
outbase = common.outbase(__file__)

import sys
from pylab import *
from numpy import *

from opendeco import vpm, tracker, mix
from opendeco.diveseries import *
from opendeco.units import msw

#m = mix.Air
m = mix.Tx(18,45)

deco = [
    (6*msw, mix.Oxygen),
    (21*msw, mix.EAN(50))
]

depth = 41.0
time = 30.0

p = common.simpleProfile(m, depth, time)
ch = SegmentChange(m, depth*msw, 40*1.013*msw, 10*msw)

v = vpm.VPM()
#v.decoMixes = deco
v.runProfile(p)

common.printSchedule(v)

figure(1)

subplot(211)
nr_it = tracker.current.plotdata('vpm.iterations').y[0]
ran = range(1, nr_it+1)
pl = []
for i in ran:
    x, y = common.fullProfile()
    pl.append( plot(x, -(y/10 +1), '-', linewidth=1) )

g = tracker.current.plotdata('tissue.deco.iter%i.gradient'%nr_it)
for i in range(16):
    if i % 2:
        continue
    plot(g.x, 1* g.y[:,i])


title('Bubble gradients during decompression')
xlabel('Runtime (min)')
ylabel('Pressure (bar)')
gca().set_xlim([20,90])

tracker.current.data = {}
subplot(212)

p = common.simpleProfile(m, depth, time)
ch = SegmentChange(m, depth*msw, 40*1.013*msw, 10*msw)

v = vpm.VPM()
v.decoMixes = deco
v.runProfile(p)

common.printSchedule(v)

nr_it = tracker.current.plotdata('vpm.iterations').y[0]
ran = range(1, nr_it+1)
pl = []
for i in ran:
    x, y = common.fullProfile()
    pl.append( plot(x, -(y/10 +1), '-', linewidth=1) )

g = tracker.current.plotdata('tissue.deco.iter%i.gradient'%nr_it)
for i in range(16):
    if i % 2:
        continue
    plot(g.x, 1* g.y[:,i])


xlabel('Runtime (min)')
ylabel('Pressure (bar)')
gca().set_xlim([20,90])

savefig(outbase+common.ext())
common.show()
