
import os
outbase = "output/" + os.path.splitext(os.path.basename(__file__))[0]

import sys
from pylab import *
from numpy import *

from opendeco import vpm, tracker, mix
from opendeco.diveseries import *
from opendeco.units import msw

depth = 60
time = 30

leg = []

def plotProfileForMixes(bottom, deco, label):
    tracker.current.data = {}

    p = DiveProfile()
    ch = SegmentChange(bottom, 0*msw, depth*msw, 30*msw)
    p.addSegment(ch)
    p.addSegment(SegmentLevel(bottom, depth*msw, time-ch.time))

    v = vpm.VPM()
    v.decoMixes = deco
    v.runProfile(p)

    nr_it = tracker.current.plotdata('vpm.iterations').y[0]
    d = tracker.current.plotdata('profile.depth')
    dd = tracker.current.plotdata('profile.deco.iter%i.depth' % nr_it)
    x = array(d.x.tolist() + dd.x.tolist())
    y = array(d.y.tolist() + dd.y.tolist())
    pl = plot(x, -y*10, '-', linewidth=1)
    leg.append( (pl, label) )

air = mix.Air
tx = mix.Tx(18, 45)
deco_o2 = [(6*msw, mix.Oxygen)]
deco_50 = [(21*msw, mix.EAN(50))]
deco_both = deco_o2 + deco_50

plotProfileForMixes(air, [], 'Air')
#plotProfileForMixes(tx, [], 'Tx18/45')
plotProfileForMixes(air, deco_o2, 'Air + O2')
plotProfileForMixes(air, deco_50, 'Air + 50')
plotProfileForMixes(air, deco_both, 'Air + O2 + 50')
#plotProfileForMixes(tx, [mix.Oxygen], 'Tx18/45 + O2')

l = legend( [ x[0] for x in leg ], [ x[1] for x in leg ], loc='best' )

savefig(outbase+'.png')

connect('button_press_event', lambda event: sys.exit(0)) 
show()

