
import common
outbase = common.outbase(__file__)

from pylab import *

from opendeco import vpm, tracker, mix
from opendeco.diveseries import *
from opendeco.units import msw

# we need it for the tissue loadings
tracker.current.resolution = 0.2

m = mix.Air

p = DiveProfile()
p.addSegment(SegmentChange(m, 0*msw, 30*msw, 15*msw))
p.addSegment(SegmentLevel(m, 30*msw, 20))
p.addSegment(SegmentChange(m, 30*msw, 15*msw, 10*msw))
p.addSegment(SegmentLevel(m, 15*msw, 20))

v = vpm.VPM()
v.runProfile(p)

x, y = common.fullProfile()
plot(x, -y, '-', linewidth=2)

tis = tracker.current.plotdata('tissue.load.n2')
y0 = tis.y[0][0]
print 'tissuerange', tis.xrange, tis.yrange
for i in range(tis.ndatasets):
    plot(tis.x, -tis.dataset(i) * 10/0.79 + (10/.79*y0))

# line at 0
plot(tis.xrange, [0, 0], '--k')

title('Multilevel dive with tissue loading scaled to the profile')
xlabel('Time (min)')
ylabel('Depth (m)')

savefig(outbase+common.ext())
savefig(outbase+'.eps')
common.show()

